const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const inventory_items = sequelize.define(
    'inventory_items',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

on_hand_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

reorder_point_quantity: {
        type: DataTypes.DECIMAL,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  inventory_items.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

























    db.inventory_items.hasMany(db.inventory_adjustments, {
      as: 'inventory_adjustments_inventory_item',
      foreignKey: {
          name: 'inventory_itemId',
      },
      constraints: false,
    });









//end loop



    db.inventory_items.belongsTo(db.products, {
      as: 'product',
      foreignKey: {
        name: 'productId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.product_variants, {
      as: 'product_variant',
      foreignKey: {
        name: 'product_variantId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.locations, {
      as: 'location',
      foreignKey: {
        name: 'locationId',
      },
      constraints: false,
    });

    db.inventory_items.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.inventory_items.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.inventory_items.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return inventory_items;
};


